rem Example drawables.bas
    
    import japi.bas
    
'    j_setdebug(1)
    
    if( j_start() = J_FALSE ) then
       print "can't connect to JAPI server"   
       end
    endif
    
    jframe = j_frame("")
    j_setborderlayout(jframe)
    
    menubar = j_menubar(jframe)
    jfile   = j_menu(menubar,"File")
    jprint  = j_menuitem(jfile,"Print")
    save    = j_menuitem(jfile,"Save BMP")
    quit    = j_menuitem(jfile,"Quit")
    canvas  = j_canvas(jframe,400,600)
    j_pack(jframe)
    j_show(jframe)
    
    a=drawgraphics(canvas,0,0,j_getwidth(canvas)-10,j_getheight(canvas)-10)
      
    obj=0
    while((obj <> jframe) and (obj <> quit))
        obj = j_nextaction()
    
        if(obj = canvas) then
            j_setnamedcolorbg(canvas,J_WHITE)
           call drawgraphics(canvas,10,10,j_getwidth(canvas)-10,j_getheight(canvas)-10)
        endif
    
        if(obj = jprint) then
           jprinter = j_printer(jframe)
           if(jprinter > 0) then
              call drawgraphics(jprinter,40,40,j_getwidth(jprinter)-80,j_getheight(jprinter)-80)
              j_print(jprinter)
           endif
        endif
    
        if(obj = save) then
           rem    NOTE: problems with WinNT 24 Bit Colordepth (use 16 Bit) 
           image = j_image(600,800)
           call drawgraphics(image,0,0,600,800)
           if(j_saveimage(image,"test.bmp",J_BMP)=J_FALSE) then
               a=j_alertbox(jframe,"Problems","Can't save image","OK")
           endif
        endif
    
    wend
    j_quit()
    
    
            
    function drawgraphics(drawable,xmin,ymin,xmax,ymax)
    
        fntsize=10
        j_setfontsize(drawable,fntsize)
        j_setnamedcolor(drawable,J_RED)
    
        rem   Drawings 
        j_drawline(drawable,xmin,ymin,xmax-1,ymax-1)
        j_drawline(drawable,xmin,ymax-1,xmax-1,ymin)
        j_drawrect(drawable,xmin,ymin,xmax-xmin-1,ymax-xmin-1)
    
        j_setnamedcolor(drawable,J_BLACK)
        j_drawline(drawable,xmin,ymax-30,xmax-1,ymax-30)
        tmpstr$ = "XMax = "+Str$(xmax)
        j_drawstring(drawable,xmax/2-j_getstringwidth(drawable,tmpstr$)/2,ymax-40,tmpstr$)
    
        j_drawline(drawable,xmin+30,ymin,xmin+30,ymax-1)
        tmpstr$ = "YMax = "+Str$(ymax)
        j_drawstring(drawable,xmin+50,40,tmpstr$)
    
        j_setnamedcolor(drawable,J_MAGENTA)
        for i=1 to 10
        	j_drawoval(drawable,xmin+(xmax-xmin)/2,ymin+(ymax-ymin)/2,(xmax-xmin)/20*i,(ymax-ymin)/20*i)
        next i
            
        rem   Text 
        j_setnamedcolor(drawable,J_BLUE)
        y=ymin
        for i=5 to 22
            j_setfontsize(drawable,i)
            x = xmax-j_getstringwidth(drawable,"JAPI Test Text")
            y = y+j_getfontheight(drawable)
            j_drawstring(drawable,x,y,"JAPI Test Text")
        next i
    
        rem   Images 
        twux = j_loadimage("images/twux.gif")
        if(twux > 0) then
            j_drawimage(drawable,twux,100,200)
            j_drawscaledimage(drawable,twux,10,0,35,30,100,300,110,138)
        endif
                
    end function
    
    
    
