rem       Example insets.bas

import japi.bas

if( j_start() = J_FALSE ) then
    print "can't connect to JAPI server"   
    end
endif

jframe     = j_frame("Insets Demo")
j_setborderlayout(jframe)

menubar = j_menubar(jframe)
jfile   = j_menu(menubar,"File")
insets  = j_menu(menubar,"Insets")
quit    = j_menuitem(jfile,"Quit")
plus    = j_menuitem(insets,"Insets + 10")
minus   = j_menuitem(insets,"Insets - 10")

canvas  = j_canvas(jframe,320,240)
j_setnamedcolor(canvas,J_RED)

j_pack(jframe)
j_show(jframe)

obj = 0
while((obj <> jframe) and (obj <> quit))
   obj=j_nextaction()
  
   if(obj = canvas) then
      j_setnamedcolorbg(canvas,J_WHITE)
      w = j_getwidth(canvas)-1
      h = j_getheight(canvas)-1
      j_drawrect(canvas,0,0,w,h)
      j_drawline(canvas,0,0,w,h)
      j_drawline(canvas,0,h,w,0)
   endif
		
   if(obj = plus) then
      j_setinsets(jframe,j_getinsets(jframe,J_TOP)+10,j_getinsets(jframe,J_BOTTOM)+10,j_getinsets(jframe,J_LEFT)+10,j_getinsets(jframe,J_RIGHT)+10)
   endif
   
   if(obj = minus) then
      j_setinsets(jframe,j_getinsets(jframe,J_TOP)-10,j_getinsets(jframe,J_BOTTOM)-10,j_getinsets(jframe,J_LEFT)-10,j_getinsets(jframe,J_RIGHT)-10)
   endif

wend    

j_quit()

 
