rem Example viewer.bas

import japi.bas

j_setdebug(0)

if( j_start() = J_FALSE ) then
    print "can't connect to JAPI server"   
    end
endif

jframe  = j_frame("Image Viewer")
menubar = j_menubar(jframe)
jfile   = j_menu(menubar,"File")
jopen   = j_menuitem(jfile,"Open")
bmp     = j_menuitem(jfile,"Save BMM")
ppm     = j_menuitem(jfile,"Save PPM")
j_seperator(jfile)
quit    = j_menuitem(jfile,"Quit")

canvas  = j_canvas(jframe,320,240)
j_setgridlayout(jframe,1,1)
j_setresizable(jframe,J_FALSE)
j_disable(bmp)
j_disable(ppm)
j_pack(jframe)
j_show(jframe)

obj = 0
while((obj <> jframe) and (obj <> quit))    
    obj =  j_nextaction()  

   if(obj = jopen) then
      filename$=j_fileselect(jframe,"Open File","*.gif")
      if(len(filename$) > 0) then
         image  = j_loadimage(filename$)
         if(image=-1) then
            alert=j_alertbox(jframe,"Warning","Not a valid image file","Shit")
         else
            j_setsize(canvas,j_getwidth(image),j_getheight(image))
            j_pack(jframe)
            j_setnamedcolorbg(canvas,J_WHITE)
    	    j_drawimage(canvas,image,0,0)
            j_enable(bmp)
            j_enable(ppm)
         endif
      endif
   endif

   if(obj = bmp) then
      filename$=j_fileselect(jframe,"Save as BMP","*.bmp")
      if(len(filename$) > 0) then 
         saved=j_saveimage(image,filename$,J_BMP)
      endif
   endif

   if(obj = ppm) then
      filename$=j_fileselect(jframe,"Save as PPM","*.ppm")
      if(len(filename$) > 0) then
         saved=j_saveimage(image,filename$,J_PPM)
      endif
   endif
wend
     
j_quit()



