rem       Example componentlistener.bas

import japi.bas

' j_setdebug(4)

if( j_start() = J_FALSE ) then
    print "can't connect to JAPI server"   
    end
endif

jframe  = j_frame("Component Listener")
j_setgridlayout(jframe,1,1)

jtext   = j_textarea(jframe,80,25)

resized = j_componentlistener(jtext,J_RESIZED)
moved   = j_componentlistener(jframe,J_MOVED)
hidden  = j_componentlistener(jtext,J_HIDDEN)
shown   = j_componentlistener(jtext,J_SHOWN)

j_show(jframe)
j_pack(jframe)


obj = 0
while(obj <> jframe)
      
    obj =  j_nextaction()  

    if(obj=resized) then
        instr$="resized to "&str$(j_getrows(jtext))&" rows "&str$(j_getcolumns(jtext))&" columns\n"
        j_appendtext(jtext,instr$)
    endif

    if(obj=moved) then
        j_appendtext(jtext,"Frame moved\n")
	if(j_isvisible(jtext)) then
	    j_settext(jframe,"Move again to see the text!")
	    j_hide(jtext)
	else
	    j_settext(jframe,"Component Listener")
	    j_show(jtext)
	endif
    endif

    if(obj=hidden) then
	j_appendtext(jtext,"Text hidden\n")
    endif
    
    if(obj=shown) then
	j_appendtext(jtext,"Text shown\n")
    endif
        
wend
       
j_quit()
end

