rem       Example mouselistener.bas

    import japi.bas
    
    if( j_start() = J_FALSE ) then
        print "can't connect to JAPI server"   
        end
    endif
    
    startx=0
    starty=0

    jframe    = j_frame("move and drag the Mouse")
    j_setsize(jframe,430,240)
    j_setnamedcolorbg(jframe,J_LIGHT_GRAY)

    canvas1  = j_canvas(jframe,200,200)
    canvas2  = j_canvas(jframe,200,200)

    j_setpos(canvas1,10,30)
    j_setpos(canvas2,220,30)

    pressed  = j_mouselistener(canvas1,J_PRESSED)
    dragged  = j_mouselistener(canvas1,J_DRAGGED)
    released = j_mouselistener(canvas1,J_RELEASED)
    entered  = j_mouselistener(canvas2,J_ENTERERD)
    moved    = j_mouselistener(canvas2,J_MOVED)
    exited   = j_mouselistener(canvas2,J_EXITED)

    j_show(jframe)

    obj=0
    while(obj<>jframe)
      
        obj=j_nextaction()

        if(obj = pressed) then
           startx=j_getmousex(pressed)
           starty=j_getmousey(pressed)
        endif

        if(obj = dragged) then
           x = j_getmousex(dragged)
           y = j_getmousey(dragged)
           j_drawrect(canvas1,startx,starty,x-startx,y-starty)
        endif

        if(obj = released) then
           x = j_getmousex(released)
           y = j_getmousey(released)
           j_drawrect(canvas1,startx,starty,x-startx,y-starty)
        endif

        if(obj = entered) then
           startx=j_getmousex(entered)
           starty=j_getmousey(entered)
        endif
    
        if(obj = moved) then
           x = j_getmousex(moved)
           y = j_getmousey(moved)
           j_drawline(canvas2,startx,starty,x,y)
           startx=x
           starty=y
        endif
        
        if(obj = exited) then
           x = j_getmousex(exited)
           y = j_getmousey(exited)
           j_drawline(canvas2,startx,starty,x,y)
        endif

    wend
    j_quit()
