rem       Example text.bas

import japi.bas

newtext$ = "JAPI (Java Application\nProgramming Interface)\na platform and language\nindependent API"

' j_setdebug(4)

if( j_start() = J_FALSE ) then
    print "can't connect to JAPI server"   
    end
endif

jframe  = j_frame("A simple editor")
menubar = j_menubar(jframe)
jfile   = j_menu(menubar,"File")
jnew    = j_menuitem(jfile,"New")
save    = j_menuitem(jfile,"Save")
j_seperator(jfile)         
quit    = j_menuitem(jfile,"Quit")


edit    = j_menu(menubar,"Edit")
selall  = j_menuitem(edit,"Select All")
j_seperator(edit)                 
cut     = j_menuitem(edit,"Cut")
copy    = j_menuitem(edit,"Copy")
paste   = j_menuitem(edit,"Paste")

jtext    = j_textarea(jframe,25,12)
j_setpos(jtext,10,60)
j_settext(jtext,newtext$)

j_show(jframe)
j_pack(jframe)
  
obj = 0
while((obj <> jframe) and (obj <> quit))
      
    obj =  j_nextaction()  

    if(obj = jtext) then
       print "text changed: ", j_getlength(jtext),"\n"
    endif
                
    if(obj = jnew) then
       j_settext(jtext,newtext$)
    endif
    
    if(obj = save) then
        inhalt$ = j_gettext(jtext)
        print inhalt$,"\n"
    endif
        
    if(obj = selall) then
       j_selectall(jtext)
    endif
                
    if((obj = cut) or (obj = copy) or (obj = paste)) then
        selstart=j_getselstart(jtext)
        selend  =j_getselend(jtext)
    endif
        
    if(obj = cut) then
        j_delete(jtext,selstart,selend)
        j_selecttext(jtext,selstart,selstart)
    endif
    
    if(obj = copy) then
       inhalt$ = j_getseltext(jtext)
    endif
        
    if(obj = paste) then
        if(selstart = selend) then
           j_inserttext(jtext,inhalt$,j_getcurpos(jtext))
        else
           j_replacetext(jtext,inhalt$,selstart,selend)
        endif
        j_setcurpos(jtext,selstart)
    endif
        
wend
       
j_quit()
end

